LeetCode 160. 相交链表

文章目录

前言

哈喽,我是长路,目前刚刚大三,方向是后端也偶尔捣鼓下前端,现在的主语言是Java。之前一大段时间都是在学习web开发的一些技术,就很久没有进行类似于数据结构、算法之类的学习与刷题,打算这段时间拾起来好好学一学、搞一搞。

这段时间也是机缘巧合看到草帽路飞的博客,加了自学群,正巧看到博主组织在群里组织了leetcode刷题打卡活动,我也就参与进来,为期一个月,打算坚持每天都花一些时间做一些题目,并通过博客的方式来进行记录。

目前跟着一个Github仓库刷题(leetcode):代码随想录leetcode刷题,当前为LeetCode 热题 HOT 100专题。



题目

题目来源leetcode

leetcode地址:160. 相交链表,难度:简单。

题目描述(摘自leetcode):

给你两个单链表的头节点 headA 和 headB ,请你找出并返回两个单链表相交的起始节点。如果两个链表没有交点,返回 null 。
图示两个链表在节点 c1 开始相交:
题目数据 保证 整个链式结构中不存在环。
注意,函数返回结果后,链表必须 保持其原始结构 。

示例 1:
输入:intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
输出:Intersected at '8'
解释:相交节点的值为 8 (注意,如果两个链表相交则不能为 0)。
从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为 [5,0,1,8,4,5]。
在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。

示例 2:
输入:intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
输出:Intersected at '2'
解释:相交节点的值为 2 (注意,如果两个链表相交则不能为 0)。
从各自的表头开始算起,链表 A 为 [0,9,1,2,4],链表 B 为 [3,2,4]。
在 A 中,相交节点前有 3 个节点;在 B 中,相交节点前有 1 个节点。

示例 3:
输入:intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
输出:null
解释:从各自的表头开始算起,链表 A 为 [2,6,4],链表 B 为 [1,5]。
由于这两个链表不相交,所以 intersectVal 必须为 0,而 skipA 和 skipB 可以是任意值。
这两个链表不相交,因此返回 null 。
 
提示:
listA 中节点数目为 m
listB 中节点数目为 n
0 <= m, n <= 3 * 104
1 <= Node.val <= 105
0 <= skipA <= m
0 <= skipB <= n
如果 listA 和 listB 没有交点,intersectVal 为 0
如果 listA 和 listB 有交点,intersectVal == listA[skipA + 1] == listB[skipB + 1]


题解

NO1:同步后缀比较

思路:首先求得两个链表的长度,根据长度差值将长的指针向后移动,直至两个链表从相同长度开始来进行一一比较得出相交结点。

代码:时间复杂度O(n),空间复杂度O(1)

class Solution {

    /**
     * 获取链表的长度
     * @param node
     * @return
     */
    public int getListNodeSize(ListNode node){
        int size = 0;
        while (node != null){
            size++;
            node = node.next;
        }
        return size;
    }

    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        if(headA == null || headB == null){
            return null;
        }
        //确定链表的长度
        int aSize = getListNodeSize(headA);
        int bSize = getListNodeSize(headB);
        //移动节点少的链表,让其成为相同长度的链表
        int moveSize = Math.abs(aSize-bSize);
        if(aSize < bSize){
            while (moveSize-- > 0){
                headB = headB.next;
            }
        }else if(aSize > bSize){
            while (moveSize-- > 0){
                headA = headA.next;
            }
        }

        //开始正式比对
        while(headA != null){
            if(headA == headB){
                return headA;
            }
            headA = headA.next;
            headB = headB.next;
        }
        return null;
    }
}

image-20211111210002978



NO2:哈希集合

思路:首先将链表A的节点全部存储到哈希集合中,之后遍历链表B来查看在哈希集合中是否存在对应的节点A。

代码:时间复杂度O(m+n),空间复杂度O(m)

public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
    if(headA == null || headB == null){
        return null;
    }
    Set<ListNode> nodes = new HashSet<>();
    while (headA != null){
        nodes.add(headA);
        headA = headA.next;
    }

    //遍历headB链表,来判断是否有相交的节点
    while (headB != null){
        if(nodes.contains(headB)){
            return headB;
        }
        headB = headB.next;
    }
    return null;
}

image-20211111211807167



NO3:双指针

思路:两个链表长度分别为m、n。两个链表同时从头节点出发,若是先碰到节点,则将该指针指到另一个链表的头节点继续两个指针向后移动,另外一个节点也是如此。最终会有两个结果:①没有交点,最终都会为null,直接结束。②有交点,两个节点相等。

规律:m+n,最终若是没有相交点,那么一定执行m+n次时都指向null,此时结束。若是有相交点,一定会相等,自己举两个例子就明白了。

代码:时间复杂度O(m+n),空间复杂度O(1)

class Solution {
    //双指针思路
    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        if(headA == null || headB == null){
            return null;
        }
        ListNode pA = headA;
        ListNode pB = headB;
        //最终会有两种情况:①没有交点,最终都会为null,直接结束。②有交点,两个节点相等。
        while(pA != pB){
            pA = pA == null ? headB : pA.next;
            pB = pB == null ? headA : pB.next;
        }
        return pA;
    }
}


参考文章

[1]. leetcode题解


我是长路,感谢你的耐心阅读。如有问题请指出,我会积极采纳! 欢迎关注我的公众号【长路Java】,分享Java学习文章及相关资料 Q群:851968786 我们可以一起探讨学习 注明:转载可,需要附带上文章链接

整理者:长路 时间:2021.11.11

评论区请在客户端页面查看